diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/random-variable-stream.h ns-3.39/src/core/model/random-variable-stream.h
--- ns-3.38/src/core/model/random-variable-stream.h	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/random-variable-stream.h	2023-07-05 14:23:47.761427200 -0700
@@ -1175,6 +1175,15 @@
     /** The sigma value for the log-normal distribution returned by this RNG stream. */
     double m_sigma;
 
+    /** True if m_normal is valid. */
+    bool m_nextValid;
+
+    /** The algorithm produces two values at a time. Cache parameters for possible reuse.*/
+    double m_v2;
+
+    /** The algorithm produces two values at a time. Cache parameters for possible reuse.*/
+    double m_normal;
+
 }; // class LogNormalRandomVariable
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/realtime-simulator-impl.cc ns-3.39/src/core/model/realtime-simulator-impl.cc
--- ns-3.38/src/core/model/realtime-simulator-impl.cc	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/realtime-simulator-impl.cc	2023-07-05 14:23:47.761427200 -0700
@@ -125,12 +125,12 @@
     // means shutting down the workers and doing a Join() before calling the
     // Simulator::Destroy().
     //
-    while (m_destroyEvents.empty() == false)
+    while (!m_destroyEvents.empty())
     {
         Ptr<EventImpl> ev = m_destroyEvents.front().PeekEventImpl();
         m_destroyEvents.pop_front();
         NS_LOG_LOGIC("handle destroy " << ev);
-        if (ev->IsCancelled() == false)
+        if (!ev->IsCancelled())
         {
             ev->Invoke();
         }
@@ -149,7 +149,7 @@
 
         if (m_events)
         {
-            while (m_events->IsEmpty() == false)
+            while (!m_events->IsEmpty())
             {
                 Scheduler::Event next = m_events->RemoveNext();
                 scheduler->Insert(next);
@@ -738,7 +738,7 @@
 void
 RealtimeSimulatorImpl::Cancel(const EventId& id)
 {
-    if (IsExpired(id) == false)
+    if (!IsExpired(id))
     {
         id.PeekEventImpl()->Cancel();
     }
@@ -773,16 +773,9 @@
     //
     // The same is true for the next line involving the m_currentUid.
     //
-    if (id.PeekEventImpl() == nullptr || id.GetTs() < m_currentTs ||
-        (id.GetTs() == m_currentTs && id.GetUid() <= m_currentUid) ||
-        id.PeekEventImpl()->IsCancelled())
-    {
-        return true;
-    }
-    else
-    {
-        return false;
-    }
+    return id.PeekEventImpl() == nullptr || id.GetTs() < m_currentTs ||
+           (id.GetTs() == m_currentTs && id.GetUid() <= m_currentUid) ||
+           id.PeekEventImpl()->IsCancelled();
 }
 
 Time
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/rng-seed-manager.h ns-3.39/src/core/model/rng-seed-manager.h
--- ns-3.38/src/core/model/rng-seed-manager.h	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/rng-seed-manager.h	2023-07-05 14:23:47.761427200 -0700
@@ -46,7 +46,7 @@
      * subsequently instantiated RandomVariableStream objects.
      *
      * \code
-     *   RngSeedManger::SetSeed(15);
+     *   RngSeedManager::SetSeed(15);
      *   UniformVariable x(2,3);     // These will give the same output every time
      *   ExponentialVariable y(120); // as long as the seed stays the same.
      * \endcode
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/rng-stream.cc ns-3.39/src/core/model/rng-stream.cc
--- ns-3.38/src/core/model/rng-stream.cc	2023-03-16 20:54:23.592868600 -0700
+++ ns-3.39/src/core/model/rng-stream.cc	2023-07-05 14:23:47.761427200 -0700
@@ -297,9 +297,9 @@
  *
  * \returns The precalculated powers of the transition matrices.
  */
-struct Precalculated PowerOfTwoConstants ()
+Precalculated PowerOfTwoConstants ()
 {
-  struct Precalculated precalculated;
+  Precalculated precalculated;
   for (int i = 0; i < 190; i++)
     {
       int power = i + 1;
@@ -317,7 +317,7 @@
  */
 void PowerOfTwoMatrix (int n, Matrix a1p, Matrix a2p)
 {
-  static struct Precalculated constants = PowerOfTwoConstants ();
+  static  Precalculated constants = PowerOfTwoConstants ();
   for (int i = 0; i < 3; i ++)
     {
       for (int j = 0; j < 3; j++)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/test.cc ns-3.39/src/core/model/test.cc
--- ns-3.38/src/core/model/test.cc	2023-03-16 20:54:23.596868500 -0700
+++ ns-3.39/src/core/model/test.cc	2023-07-05 14:23:47.765427000 -0700
@@ -63,11 +63,7 @@
     delta = std::ldexp(epsilon, exponent);
     difference = x1 - x2;
 
-    if (difference > delta || difference < -delta)
-    {
-        return false;
-    }
-    return true;
+    return difference <= delta && difference >= -delta;
 }
 
 /**
@@ -241,8 +237,8 @@
      * \returns The list of tests matching the filter constraints.
      */
     std::list<TestCase*> FilterTests(std::string testName,
-                                     enum TestSuite::Type testType,
-                                     enum TestCase::TestDuration maximumTestDuration);
+                                     TestSuite::Type testType,
+                                     TestCase::TestDuration maximumTestDuration);
 
     /** Container type for the test. */
     typedef std::vector<TestSuite*> TestSuiteVector;
@@ -302,7 +298,7 @@
 }
 
 void
-TestCase::AddTestCase(TestCase* testCase, enum TestCase::TestDuration duration)
+TestCase::AddTestCase(TestCase* testCase, TestCase::TestDuration duration)
 {
     NS_LOG_FUNCTION(&testCase << duration);
 
@@ -836,8 +832,8 @@
 
 std::list<TestCase*>
 TestRunnerImpl::FilterTests(std::string testName,
-                            enum TestSuite::Type testType,
-                            enum TestCase::TestDuration maximumTestDuration)
+                            TestSuite::Type testType,
+                            TestCase::TestDuration maximumTestDuration)
 {
     NS_LOG_FUNCTION(this << testName << testType);
     std::list<TestCase*> tests;
@@ -899,7 +895,7 @@
     bool printTestTypeList = false;
     bool printTestNameList = false;
     bool printTestTypeAndName = false;
-    enum TestCase::TestDuration maximumTestDuration = TestCase::QUICK;
+    TestCase::TestDuration maximumTestDuration = TestCase::QUICK;
     char* progname = argv[0];
 
     char** argi = argv;
@@ -1006,7 +1002,7 @@
         }
         argi++;
     }
-    enum TestSuite::Type testType;
+    TestSuite::Type testType;
     if (testTypeString.empty())
     {
         testType = TestSuite::ALL;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/test.h ns-3.39/src/core/model/test.h
--- ns-3.38/src/core/model/test.h	2023-03-16 20:54:23.596868500 -0700
+++ ns-3.39/src/core/model/test.h	2023-07-05 14:23:47.765427000 -0700
@@ -1240,7 +1240,7 @@
     std::vector<TestCase*> m_children; //!< Vector of my children
     std::string m_dataDir;             //!< My data directory
     TestRunnerImpl* m_runner;          //!< Pointer to the TestRunner
-    struct Result* m_result;           //!< Results data
+    Result* m_result;                  //!< Results data
     std::string m_name;                //!< TestCase name
     TestDuration m_duration;           //!< TestCase duration
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/time.cc ns-3.39/src/core/model/time.cc
--- ns-3.38/src/core/model/time.cc	2023-03-16 20:54:23.596868500 -0700
+++ ns-3.39/src/core/model/time.cc	2023-07-05 14:23:47.765427000 -0700
@@ -137,43 +137,43 @@
         double r;
         iss >> r;
         std::string trailer = s.substr(n, std::string::npos);
-        if (trailer == std::string("s"))
+        if (trailer == "s")
         {
             *this = Time::FromDouble(r, Time::S);
         }
-        else if (trailer == std::string("ms"))
+        else if (trailer == "ms")
         {
             *this = Time::FromDouble(r, Time::MS);
         }
-        else if (trailer == std::string("us"))
+        else if (trailer == "us")
         {
             *this = Time::FromDouble(r, Time::US);
         }
-        else if (trailer == std::string("ns"))
+        else if (trailer == "ns")
         {
             *this = Time::FromDouble(r, Time::NS);
         }
-        else if (trailer == std::string("ps"))
+        else if (trailer == "ps")
         {
             *this = Time::FromDouble(r, Time::PS);
         }
-        else if (trailer == std::string("fs"))
+        else if (trailer == "fs")
         {
             *this = Time::FromDouble(r, Time::FS);
         }
-        else if (trailer == std::string("min"))
+        else if (trailer == "min")
         {
             *this = Time::FromDouble(r, Time::MIN);
         }
-        else if (trailer == std::string("h"))
+        else if (trailer == "h")
         {
             *this = Time::FromDouble(r, Time::H);
         }
-        else if (trailer == std::string("d"))
+        else if (trailer == "d")
         {
             *this = Time::FromDouble(r, Time::D);
         }
-        else if (trailer == std::string("y"))
+        else if (trailer == "y")
         {
             *this = Time::FromDouble(r, Time::Y);
         }
@@ -199,7 +199,7 @@
 }
 
 // static
-struct Time::Resolution&
+Time::Resolution&
 Time::SetDefaultNsResolution()
 {
     NS_LOG_FUNCTION_NOARGS();
@@ -246,7 +246,7 @@
                                                << " has shift " << shift << " has quotient "
                                                << quotient);
 
-        struct Information* info = &resolution->info[i];
+        Information* info = &resolution->info[i];
         if ((std::pow(10, std::fabs(shift)) * quotient) >
             static_cast<double>(std::numeric_limits<int64_t>::max()))
         {
@@ -338,7 +338,7 @@
         ret = g_markingTimes->insert(time);
         NS_LOG_LOGIC("\t[" << g_markingTimes->size() << "] recording " << time);
 
-        if (ret.second == false)
+        if (!ret.second)
         {
             NS_LOG_WARN("already recorded " << time << "!");
         }
@@ -388,8 +388,8 @@
     for (MarkedTimes::iterator it = g_markingTimes->begin(); it != g_markingTimes->end(); it++)
     {
         Time* const tp = *it;
-        if (!((tp->m_data == std::numeric_limits<int64_t>::min()) ||
-              (tp->m_data == std::numeric_limits<int64_t>::max())))
+        if (!(tp->m_data == std::numeric_limits<int64_t>::min() ||
+              tp->m_data == std::numeric_limits<int64_t>::max()))
         {
             tp->m_data = tp->ToInteger(unit);
         }
@@ -406,7 +406,7 @@
 } // Time::ConvertTimes ()
 
 // static
-enum Time::Unit
+Time::Unit
 Time::GetResolution()
 {
     // No function log b/c it interferes with operator<<
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/timer.cc ns-3.39/src/core/model/timer.cc
--- ns-3.38/src/core/model/timer.cc	2023-03-16 20:54:23.596868500 -0700
+++ ns-3.39/src/core/model/timer.cc	2023-07-05 14:23:47.765427000 -0700
@@ -94,17 +94,13 @@
     {
     case Timer::RUNNING:
         return Simulator::GetDelayLeft(m_event);
-        break;
     case Timer::EXPIRED:
         return TimeStep(0);
-        break;
     case Timer::SUSPENDED:
         return m_delayLeft;
-        break;
     default:
         NS_ASSERT(false);
         return TimeStep(0);
-        break;
     }
 }
 
@@ -143,7 +139,7 @@
     return (m_flags & TIMER_SUSPENDED) == TIMER_SUSPENDED;
 }
 
-enum Timer::State
+Timer::State
 Timer::GetState() const
 {
     NS_LOG_FUNCTION(this);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/timer.h ns-3.39/src/core/model/timer.h
--- ns-3.38/src/core/model/timer.h	2023-03-16 20:54:23.596868500 -0700
+++ ns-3.39/src/core/model/timer.h	2023-07-05 14:23:47.765427000 -0700
@@ -198,7 +198,7 @@
     /**
      * \returns The current state of the timer.
      */
-    enum Timer::State GetState() const;
+    Timer::State GetState() const;
     /**
      * Schedule a new event using the currently-configured delay, function,
      * and arguments.
@@ -233,11 +233,8 @@
     void Resume();
 
   private:
-    /** Internal bit marking the suspended state. */
-    enum InternalSuspended
-    {
-        TIMER_SUSPENDED = (1 << 7) /** Timer suspended. */
-    };
+    /** Internal bit marking the suspended timer state */
+    static constexpr auto TIMER_SUSPENDED{1 << 7};
 
     /**
      * Bitfield for Timer State, DestroyPolicy and InternalSuspended.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/timer-impl.h ns-3.39/src/core/model/timer-impl.h
--- ns-3.38/src/core/model/timer-impl.h	2023-03-16 20:54:23.596868500 -0700
+++ ns-3.39/src/core/model/timer-impl.h	2023-07-05 14:23:47.765427000 -0700
@@ -1084,7 +1084,7 @@
 void
 TimerImpl::SetArgs(T1 a1)
 {
-    typedef struct TimerImplOne<typename TimerTraits<T1>::ParameterType> TimerImplBase;
+    typedef TimerImplOne<typename TimerTraits<T1>::ParameterType> TimerImplBase;
     TimerImplBase* impl = dynamic_cast<TimerImplBase*>(this);
     if (impl == nullptr)
     {
@@ -1098,8 +1098,8 @@
 void
 TimerImpl::SetArgs(T1 a1, T2 a2)
 {
-    typedef struct TimerImplTwo<typename TimerTraits<T1>::ParameterType,
-                                typename TimerTraits<T2>::ParameterType>
+    typedef TimerImplTwo<typename TimerTraits<T1>::ParameterType,
+                         typename TimerTraits<T2>::ParameterType>
         TimerImplBase;
     TimerImplBase* impl = dynamic_cast<TimerImplBase*>(this);
     if (impl == nullptr)
@@ -1114,9 +1114,9 @@
 void
 TimerImpl::SetArgs(T1 a1, T2 a2, T3 a3)
 {
-    typedef struct TimerImplThree<typename TimerTraits<T1>::ParameterType,
-                                  typename TimerTraits<T2>::ParameterType,
-                                  typename TimerTraits<T3>::ParameterType>
+    typedef TimerImplThree<typename TimerTraits<T1>::ParameterType,
+                           typename TimerTraits<T2>::ParameterType,
+                           typename TimerTraits<T3>::ParameterType>
         TimerImplBase;
     TimerImplBase* impl = dynamic_cast<TimerImplBase*>(this);
     if (impl == nullptr)
@@ -1131,10 +1131,10 @@
 void
 TimerImpl::SetArgs(T1 a1, T2 a2, T3 a3, T4 a4)
 {
-    typedef struct TimerImplFour<typename TimerTraits<T1>::ParameterType,
-                                 typename TimerTraits<T2>::ParameterType,
-                                 typename TimerTraits<T3>::ParameterType,
-                                 typename TimerTraits<T4>::ParameterType>
+    typedef TimerImplFour<typename TimerTraits<T1>::ParameterType,
+                          typename TimerTraits<T2>::ParameterType,
+                          typename TimerTraits<T3>::ParameterType,
+                          typename TimerTraits<T4>::ParameterType>
         TimerImplBase;
     TimerImplBase* impl = dynamic_cast<TimerImplBase*>(this);
     if (impl == nullptr)
@@ -1149,11 +1149,11 @@
 void
 TimerImpl::SetArgs(T1 a1, T2 a2, T3 a3, T4 a4, T5 a5)
 {
-    typedef struct TimerImplFive<typename TimerTraits<T1>::ParameterType,
-                                 typename TimerTraits<T2>::ParameterType,
-                                 typename TimerTraits<T3>::ParameterType,
-                                 typename TimerTraits<T4>::ParameterType,
-                                 typename TimerTraits<T5>::ParameterType>
+    typedef TimerImplFive<typename TimerTraits<T1>::ParameterType,
+                          typename TimerTraits<T2>::ParameterType,
+                          typename TimerTraits<T3>::ParameterType,
+                          typename TimerTraits<T4>::ParameterType,
+                          typename TimerTraits<T5>::ParameterType>
         TimerImplBase;
     TimerImplBase* impl = dynamic_cast<TimerImplBase*>(this);
     if (impl == nullptr)
@@ -1168,12 +1168,12 @@
 void
 TimerImpl::SetArgs(T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6)
 {
-    typedef struct TimerImplSix<typename TimerTraits<T1>::ParameterType,
-                                typename TimerTraits<T2>::ParameterType,
-                                typename TimerTraits<T3>::ParameterType,
-                                typename TimerTraits<T4>::ParameterType,
-                                typename TimerTraits<T5>::ParameterType,
-                                typename TimerTraits<T6>::ParameterType>
+    typedef TimerImplSix<typename TimerTraits<T1>::ParameterType,
+                         typename TimerTraits<T2>::ParameterType,
+                         typename TimerTraits<T3>::ParameterType,
+                         typename TimerTraits<T4>::ParameterType,
+                         typename TimerTraits<T5>::ParameterType,
+                         typename TimerTraits<T6>::ParameterType>
         TimerImplBase;
     TimerImplBase* impl = dynamic_cast<TimerImplBase*>(this);
     if (impl == 0)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/type-id.cc ns-3.39/src/core/model/type-id.cc
--- ns-3.38/src/core/model/type-id.cc	2023-03-16 20:54:23.596868500 -0700
+++ ns-3.39/src/core/model/type-id.cc	2023-07-05 14:23:47.765427000 -0700
@@ -228,7 +228,7 @@
      * \param [in] i Index into attribute array
      * \returns The information associated to attribute whose index is \pname{i}.
      */
-    struct TypeId::AttributeInformation GetAttribute(uint16_t uid, std::size_t i) const;
+    TypeId::AttributeInformation GetAttribute(uint16_t uid, std::size_t i) const;
     /**
      * Record a new TraceSource.
      * \param [in] uid The id.
@@ -262,7 +262,7 @@
      * \param [in] i Index into trace source array.
      * \returns Detailed information about the requested trace source.
      */
-    struct TypeId::TraceSourceInformation GetTraceSource(uint16_t uid, std::size_t i) const;
+    TypeId::TraceSourceInformation GetTraceSource(uint16_t uid, std::size_t i) const;
     /**
      * Check if this TypeId should not be listed in documentation.
      * \param [in] uid The id.
@@ -312,26 +312,27 @@
         /** \c true if this type should be omitted from documentation. */
         bool mustHideFromDocumentation;
         /** The container of Attributes. */
-        std::vector<struct TypeId::AttributeInformation> attributes;
+        std::vector<TypeId::AttributeInformation> attributes;
         /** The container of TraceSources. */
-        std::vector<struct TypeId::TraceSourceInformation> traceSources;
+        std::vector<TypeId::TraceSourceInformation> traceSources;
         /** Support level/deprecation. */
         TypeId::SupportLevel supportLevel;
         /** Support message. */
         std::string supportMsg;
     };
+
     /** Iterator type. */
-    typedef std::vector<struct IidInformation>::const_iterator Iterator;
+    typedef std::vector<IidInformation>::const_iterator Iterator;
 
     /**
      * Retrieve the information record for a type.
      * \param [in] uid The id.
      * \returns The information record.
      */
-    struct IidManager::IidInformation* LookupInformation(uint16_t uid) const;
+    IidManager::IidInformation* LookupInformation(uint16_t uid) const;
 
     /** The container of all type id records. */
-    std::vector<struct IidInformation> m_information;
+    std::vector<IidInformation> m_information;
 
     /** Type of the by-name index. */
     typedef std::map<std::string, uint16_t> namemap_t;
@@ -413,7 +414,7 @@
         // into ns3.  -- Peter Barnes, LLNL
 
         // Alphabetize the two types, so it's deterministic
-        struct IidInformation* hinfo = LookupInformation(GetUid(hash));
+        IidInformation* hinfo = LookupInformation(GetUid(hash));
         if (name > hinfo->name)
         { // new type gets chained
             NS_LOG_LOGIC(IIDL << "New TypeId '" << name << "' getting chained.");
@@ -451,13 +452,13 @@
     return uid;
 }
 
-struct IidManager::IidInformation*
+IidManager::IidInformation*
 IidManager::LookupInformation(uint16_t uid) const
 {
     NS_LOG_FUNCTION(IID << uid);
     NS_ASSERT(uid <= m_information.size() && uid != 0);
     NS_LOG_LOGIC(IIDL << m_information[uid - 1].name);
-    return const_cast<struct IidInformation*>(&m_information[uid - 1]);
+    return const_cast<IidInformation*>(&m_information[uid - 1]);
 }
 
 void
@@ -465,7 +466,7 @@
 {
     NS_LOG_FUNCTION(IID << uid << parent);
     NS_ASSERT(parent <= m_information.size());
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     information->parent = parent;
 }
 
@@ -473,7 +474,7 @@
 IidManager::SetGroupName(uint16_t uid, std::string groupName)
 {
     NS_LOG_FUNCTION(IID << uid << groupName);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     information->groupName = groupName;
 }
 
@@ -481,7 +482,7 @@
 IidManager::SetSize(uint16_t uid, std::size_t size)
 {
     NS_LOG_FUNCTION(IID << uid << size);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     information->size = size;
 }
 
@@ -489,7 +490,7 @@
 IidManager::HideFromDocumentation(uint16_t uid)
 {
     NS_LOG_FUNCTION(IID << uid);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     information->mustHideFromDocumentation = true;
 }
 
@@ -497,7 +498,7 @@
 IidManager::AddConstructor(uint16_t uid, Callback<ObjectBase*> callback)
 {
     NS_LOG_FUNCTION(IID << uid << &callback);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     if (information->hasConstructor)
     {
         NS_FATAL_ERROR(information->name << " already has a constructor.");
@@ -538,7 +539,7 @@
 IidManager::GetName(uint16_t uid) const
 {
     NS_LOG_FUNCTION(IID << uid);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     NS_LOG_LOGIC(IIDL << information->name);
     return information->name;
 }
@@ -547,7 +548,7 @@
 IidManager::GetHash(uint16_t uid) const
 {
     NS_LOG_FUNCTION(IID << uid);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     TypeId::hash_t hash = information->hash;
     NS_LOG_LOGIC(IIDL << hash);
     return hash;
@@ -557,7 +558,7 @@
 IidManager::GetParent(uint16_t uid) const
 {
     NS_LOG_FUNCTION(IID << uid);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     uint16_t pid = information->parent;
     NS_LOG_LOGIC(IIDL << pid);
     return pid;
@@ -567,7 +568,7 @@
 IidManager::GetGroupName(uint16_t uid) const
 {
     NS_LOG_FUNCTION(IID << uid);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     NS_LOG_LOGIC(IIDL << information->groupName);
     return information->groupName;
 }
@@ -576,7 +577,7 @@
 IidManager::GetSize(uint16_t uid) const
 {
     NS_LOG_FUNCTION(IID << uid);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     std::size_t size = information->size;
     NS_LOG_LOGIC(IIDL << size);
     return size;
@@ -586,7 +587,7 @@
 IidManager::GetConstructor(uint16_t uid) const
 {
     NS_LOG_FUNCTION(IID << uid);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     if (!information->hasConstructor)
     {
         NS_FATAL_ERROR("Requested constructor for " << information->name
@@ -599,7 +600,7 @@
 IidManager::HasConstructor(uint16_t uid) const
 {
     NS_LOG_FUNCTION(IID << uid);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     bool hasC = information->hasConstructor;
     NS_LOG_LOGIC(IIDL << hasC);
     return hasC;
@@ -623,10 +624,10 @@
 IidManager::HasAttribute(uint16_t uid, std::string name)
 {
     NS_LOG_FUNCTION(IID << uid << name);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     while (true)
     {
-        for (std::vector<struct TypeId::AttributeInformation>::const_iterator i =
+        for (std::vector<TypeId::AttributeInformation>::const_iterator i =
                  information->attributes.begin();
              i != information->attributes.end();
              ++i)
@@ -637,7 +638,7 @@
                 return true;
             }
         }
-        struct IidInformation* parent = LookupInformation(information->parent);
+        IidInformation* parent = LookupInformation(information->parent);
         if (parent == information)
         {
             // top of inheritance tree
@@ -664,7 +665,7 @@
 {
     NS_LOG_FUNCTION(IID << uid << name << help << flags << initialValue << accessor << checker
                         << supportLevel << supportMsg);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     if (name.find(' ') != std::string::npos)
     {
         NS_FATAL_ERROR("Attribute name \"" << name << "\" may not contain spaces ' ', "
@@ -676,7 +677,7 @@
         NS_FATAL_ERROR("Attribute \"" << name << "\" already registered on tid=\""
                                       << information->name << "\"");
     }
-    struct TypeId::AttributeInformation info;
+    TypeId::AttributeInformation info;
     info.name = name;
     info.help = help;
     info.flags = flags;
@@ -696,7 +697,7 @@
                                      Ptr<const AttributeValue> initialValue)
 {
     NS_LOG_FUNCTION(IID << uid << i << initialValue);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     NS_ASSERT(i < information->attributes.size());
     information->attributes[i].initialValue = initialValue;
 }
@@ -705,17 +706,17 @@
 IidManager::GetAttributeN(uint16_t uid) const
 {
     NS_LOG_FUNCTION(IID << uid);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     std::size_t size = information->attributes.size();
     NS_LOG_LOGIC(IIDL << size);
     return size;
 }
 
-struct TypeId::AttributeInformation
+TypeId::AttributeInformation
 IidManager::GetAttribute(uint16_t uid, std::size_t i) const
 {
     NS_LOG_FUNCTION(IID << uid << i);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     NS_ASSERT(i < information->attributes.size());
     NS_LOG_LOGIC(IIDL << information->name);
     return information->attributes[i];
@@ -725,10 +726,10 @@
 IidManager::HasTraceSource(uint16_t uid, std::string name)
 {
     NS_LOG_FUNCTION(IID << uid << name);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     while (true)
     {
-        for (std::vector<struct TypeId::TraceSourceInformation>::const_iterator i =
+        for (std::vector<TypeId::TraceSourceInformation>::const_iterator i =
                  information->traceSources.begin();
              i != information->traceSources.end();
              ++i)
@@ -739,7 +740,7 @@
                 return true;
             }
         }
-        struct IidInformation* parent = LookupInformation(information->parent);
+        IidInformation* parent = LookupInformation(information->parent);
         if (parent == information)
         {
             // top of inheritance tree
@@ -764,13 +765,13 @@
 {
     NS_LOG_FUNCTION(IID << uid << name << help << accessor << callback << supportLevel
                         << supportMsg);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     if (HasTraceSource(uid, name))
     {
         NS_FATAL_ERROR("Trace source \"" << name << "\" already registered on tid=\""
                                          << information->name << "\"");
     }
-    struct TypeId::TraceSourceInformation source;
+    TypeId::TraceSourceInformation source;
     source.name = name;
     source.help = help;
     source.accessor = accessor;
@@ -785,17 +786,17 @@
 IidManager::GetTraceSourceN(uint16_t uid) const
 {
     NS_LOG_FUNCTION(IID << uid);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     std::size_t size = information->traceSources.size();
     NS_LOG_LOGIC(IIDL << size);
     return size;
 }
 
-struct TypeId::TraceSourceInformation
+TypeId::TraceSourceInformation
 IidManager::GetTraceSource(uint16_t uid, std::size_t i) const
 {
     NS_LOG_FUNCTION(IID << uid << i);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     NS_ASSERT(i < information->traceSources.size());
     NS_LOG_LOGIC(IIDL << information->name);
     return information->traceSources[i];
@@ -805,7 +806,7 @@
 IidManager::MustHideFromDocumentation(uint16_t uid) const
 {
     NS_LOG_FUNCTION(IID << uid);
-    struct IidInformation* information = LookupInformation(uid);
+    IidInformation* information = LookupInformation(uid);
     bool hide = information->mustHideFromDocumentation;
     NS_LOG_LOGIC(IIDL << hide);
     return hide;
@@ -894,7 +895,7 @@
 }
 
 bool
-TypeId::LookupAttributeByName(std::string name, struct TypeId::AttributeInformation* info) const
+TypeId::LookupAttributeByName(std::string name, TypeId::AttributeInformation* info) const
 {
     NS_LOG_FUNCTION(this << name << info);
     TypeId tid;
@@ -904,7 +905,7 @@
         tid = nextTid;
         for (std::size_t i = 0; i < tid.GetAttributeN(); i++)
         {
-            struct TypeId::AttributeInformation tmp = tid.GetAttribute(i);
+            TypeId::AttributeInformation tmp = tid.GetAttribute(i);
             if (tmp.name == name)
             {
                 if (tmp.supportLevel == TypeId::SUPPORTED)
@@ -1108,7 +1109,7 @@
     return n;
 }
 
-struct TypeId::AttributeInformation
+TypeId::AttributeInformation
 TypeId::GetAttribute(std::size_t i) const
 {
     NS_LOG_FUNCTION(this << i);
@@ -1119,7 +1120,7 @@
 TypeId::GetAttributeFullName(std::size_t i) const
 {
     NS_LOG_FUNCTION(this << i);
-    struct TypeId::AttributeInformation info = GetAttribute(i);
+    TypeId::AttributeInformation info = GetAttribute(i);
     return GetName() + "::" + info.name;
 }
 
@@ -1130,7 +1131,7 @@
     return IidManager::Get()->GetTraceSourceN(m_tid);
 }
 
-struct TypeId::TraceSourceInformation
+TypeId::TraceSourceInformation
 TypeId::GetTraceSource(std::size_t i) const
 {
     NS_LOG_FUNCTION(this << i);
@@ -1160,12 +1161,12 @@
 }
 
 Ptr<const TraceSourceAccessor>
-TypeId::LookupTraceSourceByName(std::string name, struct TraceSourceInformation* info) const
+TypeId::LookupTraceSourceByName(std::string name, TraceSourceInformation* info) const
 {
     NS_LOG_FUNCTION(this << name);
     TypeId tid;
     TypeId nextTid = *this;
-    struct TypeId::TraceSourceInformation tmp;
+    TypeId::TraceSourceInformation tmp;
     do
     {
         tid = nextTid;
